package com.ruoyi.system.utils;

import java.util.HashSet;
import java.util.Set;
import java.io.IOException;
import java.net.SocketAddress;
import java.net.InetSocketAddress;
import java.net.Socket;

public class IPChecker
{
    public static void main(final String[] args) {
        System.out.println(isPortOpen("43.156.165.73", 3306));
    }
    
    public static boolean isPortOpen(final String ipAddress, final int port) {
        try (final Socket socket = new Socket()) {
            socket.connect(new InetSocketAddress(ipAddress, port), 5000);
            return true;
        }
        catch (final IOException e) {
            return false;
        }
    }
    
    public static Set<Integer> checkMultiplePorts(final String ipAddress, final Integer... ports) {
        final Set<Integer> noOpenPorts = new HashSet<Integer>();
        for (final Integer port : ports) {
            if (port != null) {
                final boolean isOpen = isPortOpen(ipAddress, port);
                if (!isOpen) {
                    noOpenPorts.add(port);
                }
            }
        }
        return noOpenPorts;
    }
}
